Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkQuadraticTriangle Class Reference

`#include <vtkQuadraticTriangle.h>`

Inheritance diagram for vtkQuadraticTriangle:

[legend]
Collaboration diagram for vtkQuadraticTriangle:

[legend]
List of all members.

## Detailed Description

cell represents a parabolic, isoparametric triangle

Date:
  2002/11/12 18:55:41

Revision:
  1.5

vtkQuadraticTriangle is a concrete implementation of vtkNonLinearCell to represent a two-dimensional, 6-node, isoparametric parabolic triangle. The interpolation is the standard finite element, quadratic isoparametric shape function. The cell includes three mid-edge nodes besides the three triangle vertices. The ordering of the three points defining the cell is point ids (0-2,3-5) where id #3 is the midedge node between points (0,1); id #4 is the midedge node between points (1,2); and id #5 is the midedge node between points (2,0).

See also:
  vtkQuadraticEdge vtkQuadraticTetra vtQuadraticQuad vtkQuadraticHexahedron

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (98%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkQuadraticTriangle.h)`
  - .`cxx` (`/Common/vtkQuadraticTriangle.cxx)`

Tests:
  vtkQuadraticTriangle (Tests)

Definition at line 58 of file vtkQuadraticTriangle.h.

## Public Types
typedef vtkNonLinearCell | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
int | CellBoundary (int subId, float pcoords[3], vtkIdList *pts)
void | Contour (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd)
int | EvaluatePosition (float x[3], float *closestPoint, int &subId, float pcoords[3], float &dist2, float *weights)
void | EvaluateLocation (int &subId, float pcoords[3], float x[3], float *weights)
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts)
void | Derivatives (int subId, float pcoords[3], float *values, int dim, float *derivs)
int | GetParametricCenter (float pcoords[3])
int | GetCellType ()
int | GetCellDimension ()
int | GetNumberOfEdges ()
int | GetNumberOfFaces ()
vtkCell * | GetEdge (int edgeId)
vtkCell * | GetFace (int)
void | Clip (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut)
int | IntersectWithLine (float p1[3], float p2[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
## Static Public Methods
vtkQuadraticTriangle * | New ()
int | IsTypeOf (const char *type)
vtkQuadraticTriangle * | SafeDownCast (vtkObject *o)
void | InterpolationFunctions (float pcoords[3], float weights[3])
void | InterpolationDerivs (float pcoords[3], float derivs[3])
## Protected Methods
| vtkQuadraticTriangle ()
| ~vtkQuadraticTriangle ()
## Protected Attributes
vtkQuadraticEdge * | Edge
vtkTriangle * | Face
vtkFloatArray * | Scalars

## Member Typedef Documentation

typedef vtkNonLinearCell vtkQuadraticTriangle::Superclass

| Reimplemented from vtkNonLinearCell. Definition at line 62 of file vtkQuadraticTriangle.h.

## Constructor & Destructor Documentation

vtkQuadraticTriangle::vtkQuadraticTriangle | ( |  | ) | `[protected]`

vtkQuadraticTriangle::~vtkQuadraticTriangle | ( |  | ) | `[protected]`

## Member Function Documentation

vtkQuadraticTriangle* vtkQuadraticTriangle::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkQuadraticTriangle::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkNonLinearCell.

int vtkQuadraticTriangle::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkNonLinearCell.

virtual int vtkQuadraticTriangle::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkNonLinearCell.

vtkQuadraticTriangle* vtkQuadraticTriangle::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkNonLinearCell.

int vtkQuadraticTriangle::GetCellType | ( |  | ) | `[inline, virtual]`

| Implement the vtkCell API. See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 67 of file vtkQuadraticTriangle.h. References VTK_QUADRATIC_TRIANGLE.

int vtkQuadraticTriangle::GetCellDimension | ( |  | ) | `[inline, virtual]`

| Implement the vtkCell API. See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 68 of file vtkQuadraticTriangle.h.

int vtkQuadraticTriangle::GetNumberOfEdges | ( |  | ) | `[inline, virtual]`

| Implement the vtkCell API. See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 69 of file vtkQuadraticTriangle.h.

int vtkQuadraticTriangle::GetNumberOfFaces | ( |  | ) | `[inline, virtual]`

| Implement the vtkCell API. See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 70 of file vtkQuadraticTriangle.h.

vtkCell* vtkQuadraticTriangle::GetEdge | ( | int | edgeId | ) | `[virtual]`

| Implement the vtkCell API. See the vtkCell API for descriptions of these methods. Implements vtkCell.

vtkCell* vtkQuadraticTriangle::GetFace | ( | int |  | ) | `[inline, virtual]`

| Implement the vtkCell API. See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 72 of file vtkQuadraticTriangle.h.

int vtkQuadraticTriangle::CellBoundary | ( | int | subId,
|  | float | pcoords[3],
|  | vtkIdList * | pts
| ) | `[virtual]`

| Given parametric coordinates of a point, return the closest cell boundary, and whether the point is inside or outside of the cell. The cell boundary is defined by a list of points (pts) that specify a face (3D cell), edge (2D cell), or vertex (1D cell). If the return value of the method is != 0, then the point is inside the cell. Implements vtkCell.

void vtkQuadraticTriangle::Contour | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) | `[virtual]`

| Generate contouring primitives. The scalar list cellScalars are scalar values at each cell point. The point locator is essentially a points list that merges points as they are inserted (i.e., prevents duplicates). Contouring primitives can be vertices, lines, or polygons. It is possible to interpolate point data along the edge by providing input and output point data - if outPd is NULL, then no interpolation is performed. Also, if the output cell data is non-NULL, the cell data from the contoured cell is passed to the generated contouring primitives. (Note: the CopyAllocate() method must be invoked on both the output cell and point data. The cellId refers to the cell from which the cell data is copied.) Implements vtkCell.

int vtkQuadraticTriangle::EvaluatePosition | ( | float | x[3],
|  | float * | closestPoint,
|  | int & | subId,
|  | float | pcoords[3],
|  | float & | dist2,
|  | float * | weights
| ) | `[virtual]`

| Given a point x[3] return inside(=1) or outside(=0) cell; evaluate parametric coordinates, sub-cell id (!=0 only if cell is composite), distance squared of point x[3] to cell (in particular, the sub-cell indicated), closest point on cell to x[3] (unless closestPoint is null, in which case, the closest point and dist2 are not found), and interpolation weights in cell. (The number of weights is equal to the number of points defining the cell). Note: on rare occasions a -1 is returned from the method. This means that numerical error has occurred and all data returned from this method should be ignored. Also, inside/outside is determine parametrically. That is, a point is inside if it satisfies parametric limits. This can cause problems for cells of topological dimension 2 or less, since a point in 3D can project onto the cell within parametric limits but be "far" from the cell. Thus the value dist2 may be checked to determine true in/out. Implements vtkCell.

void vtkQuadraticTriangle::EvaluateLocation | ( | int & | subId,
|  | float | pcoords[3],
|  | float | x[3],
|  | float * | weights
| ) | `[virtual]`

| Determine global coordinate (x[3]) from subId and parametric coordinates. Also returns interpolation weights. (The number of weights is equal to the number of points in the cell.) Implements vtkCell.

int vtkQuadraticTriangle::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) | `[virtual]`

| Generate simplices of proper dimension. If cell is 3D, tetrahedron are generated; if 2D triangles; if 1D lines; if 0D points. The form of the output is a sequence of points, each n+1 points (where n is topological cell dimension) defining a simplex. The index is a parameter that controls which triangulation to use (if more than one is possible). If numerical degeneracy encountered, 0 is returned, otherwise 1 is returned. Implements vtkCell.

void vtkQuadraticTriangle::Derivatives | ( | int | subId,
|  | float | pcoords[3],
|  | float * | values,
|  | int | dim,
|  | float * | derivs
| ) | `[virtual]`

| Compute derivatives given cell subId and parametric coordinates. The values array is a series of data value(s) at the cell points. There is a one-to-one correspondence between cell point and data value(s). Dim is the number of data values per cell point. Derivs are derivatives in the x-y-z coordinate directions for each data value. Thus, if computing derivatives for a scalar function in a hexahedron, dim=1, 8 values are supplied, and 3 deriv values are returned (i.e., derivatives in x-y-z directions). On the other hand, if computing derivatives of velocity (vx,vy,vz) dim=3, 24 values are supplied ((vx,vy,vz)1, (vx,vy,vz)2, ....()8), and 9 deriv values are returned ((d(vx)/dx),(d(vx)/dy),(d(vx)/dz), (d(vy)/dx),(d(vy)/dy), (d(vy)/dz), (d(vz)/dx),(d(vz)/dy),(d(vz)/dz)). Implements vtkCell.

void vtkQuadraticTriangle::Clip | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd,
|  | int | insideOut
| ) | `[virtual]`

| Clip this quadratic triangle using scalar value provided. Like contouring, except that it cuts the triangle to produce linear triangles. Implements vtkCell.

int vtkQuadraticTriangle::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| Line-edge intersection. Intersection has to occur within [0,1] parametric coordinates and with specified tolerance. Implements vtkCell.

int vtkQuadraticTriangle::GetParametricCenter | ( | float | pcoords[3] | ) | `[virtual]`

| Return the center of the quadratic triangle in parametric coordinates. Reimplemented from vtkCell.

void vtkQuadraticTriangle::InterpolationFunctions | ( | float | pcoords[3],
|  | float | weights[3]
| ) | `[static]`

| Quadratic triangle specific methods.

void vtkQuadraticTriangle::InterpolationDerivs | ( | float | pcoords[3],
|  | float | derivs[3]
| ) | `[static]`

| Quadratic triangle specific methods.

## Member Data Documentation

vtkQuadraticEdge* vtkQuadraticTriangle::Edge`[protected]`

| Definition at line 123 of file vtkQuadraticTriangle.h.

vtkTriangle* vtkQuadraticTriangle::Face`[protected]`

| Definition at line 124 of file vtkQuadraticTriangle.h.

vtkFloatArray* vtkQuadraticTriangle::Scalars`[protected]`

| Definition at line 125 of file vtkQuadraticTriangle.h.

The documentation for this class was generated from the following file:

- Common/vtkQuadraticTriangle.h